package testy

import (
	"io/ioutil"
	"testing"
)

func TestFile(t *testing.T) {
	tests := []struct {
		name     string
		path     string
		expected string
		err      string
	}{
		{
			name: "not found",
			path: "./not_found",
			err:  "",
		},
		{
			name:     "found",
			path:     "testdata/test.txt",
			expected: "Test Content\n",
		},
	}
	for _, test := range tests {
		content, err := ioutil.ReadAll(&File{Path: test.path})
		Error(t, test.err, err)
		if test.expected != string(content) {
			t.Errorf("Unexpected content: %s\n", string(content))
		}
	}
}

func TestSnapshot(t *testing.T) {
	t.Run("Test:Name:With:Colon", func(t *testing.T) {
		file := Snapshot(t)
		content, err := ioutil.ReadAll(file)
		Error(t, "", err)
		if "test content\n" != string(content) {
			t.Errorf("Unexpected content: %s\n", string(content))
		}
	})
}
